// inspiration
// main.js
// All code copyright (c) 2005, Martin Koistinen

var quotations;
var textLines  = new Array();
var textObjs   = new Array();
var maxZOrder = 0;
var lastUpdate = 0;
var lastQuote = "";
var lastJustify = preferences.textJustify.value;
var initialState = true;
var sourceFileName = "inspiration.txt";

function buildContextMenu()
{
	var cmi = new Array();
	var num = -1;
	
	cmi[++num] = new MenuItem();
	cmi[num].title = "Save theme...";
	cmi[num].enabled = true;
	cmi[num].onSelect = "saveTheme();";

	theme1 = preferences.theme1.value.split(',');
	theme2 = preferences.theme2.value.split(',');
	theme3 = preferences.theme3.value.split(',');
	theme4 = preferences.theme4.value.split(',');
	theme5 = preferences.theme5.value.split(',');

	if (theme1.length > 8)
	{
		cmi[++num] = new MenuItem();
		cmi[num].title = "Use " + theme1[0];
		cmi[num].checked = compareTheme(1) == true;
		cmi[num].enabled = true;
		cmi[num].onSelect = "loadTheme(1);";
	}
	
	if (theme2.length > 8)
	{
		cmi[++num] = new MenuItem();
		cmi[num].title = "Use " + theme2[0];
		cmi[num].checked = compareTheme(2) == true;
		cmi[num].enabled = true;
		cmi[num].onSelect = "loadTheme(2);";
	}
	
	if (theme3.length > 8)
	{
		cmi[++num] = new MenuItem();
		cmi[num].title = "Use " + theme3[0];
		cmi[num].checked = compareTheme(3) == true;
		cmi[num].enabled = true;
		cmi[num].onSelect = "loadTheme(3);";
	}
	
	if (theme4.length > 8)
	{
		cmi[++num] = new MenuItem();
		cmi[num].title = "Use " + theme4[0];
		cmi[num].checked = compareTheme(4) == true;
		cmi[num].enabled = true;
		cmi[num].onSelect = "loadTheme(4);";
	}
	
	if (theme5.length > 8)
	{
		cmi[++num] = new MenuItem();
		cmi[num].title = "Use " + theme5[0];
		cmi[num].checked = compareTheme(5) == true;
		cmi[num].enabled = true;
		cmi[num].onSelect = "loadTheme(5);";
	}

	cmi[++num] = new MenuItem();
	cmi[num].title = "Use default theme";
	cmi[num].checked = compareTheme(0) == true;
	cmi[num].enabled = true;
	cmi[num].onSelect = "loadTheme(0);";
	
	cmi[++num] = new MenuItem(); // separator
	cmi[num].title = "-";
	cmi[num].enabled = false;

	cmi[++num] = new MenuItem();
	cmi[num].title = "Open '" + sourceFileName + "'";
	cmi[num].enabled = true;
	cmi[num].onSelect = "openQuotes();";

	cmi[++num] = new MenuItem();
	cmi[num].title = "Reveal '" + sourceFileName + "'";
	cmi[num].enabled = true;
	cmi[num].onSelect = "revealQuotes();";

	cmi[++num] = new MenuItem();
	cmi[num].title = "Reload '" + sourceFileName + "'";
	cmi[num].enabled = true;
	cmi[num].onSelect = "loadQuotes(); updateDisplay(true);";

	cmi[++num] = new MenuItem(); // separator
	cmi[num].title = "-";
	cmi[num].enabled = false;

	cmi[++num] = new MenuItem();
	cmi[num].title = "Reset reminders";
	cmi[num].enabled = (preferences.remindEdit.value == "false" || preferences.remindThemeName.value == "false");
	cmi[num].onSelect = "resetReminders();";
	
	mainWindow.contextMenuItems = cmi;
}

function instructUser()
{
	if (preferences.remindEdit.value != "false")
	{
		var response = alert("Your " + sourceFileName + " file should have one inspiring quote per line.  Asterixes (*) within the quote will break the quotation into multiple lines of text when displayed.  For best result, try to break each quotation into 40-50 character lines.", "Don't remind me anymore!", "OK");
		if (response == 1)
		{	
			preferences.remindEdit.value = "false";
			savePreferences();
		}
	}
}

function resetReminders()
{
	preferences.remindEdit.value = "true";
	preferences.remindThemeName.value = "true";
	savePreferences();
}

function saveTheme(defaultTheme)
{
	if (defaultTheme)
	{
		themeName = "Default";
	}
	else
	{
		if (preferences.remindThemeName.value != "false")
		{
			var response = alert("You can save up to 5 uniquely named themes.  Older themes are replaced with newer ones.  If you use the same name as a previously saved theme, the previous theme is replaced.", "Don't remind me anymore!", "OK");
			if (response == 1)
			{	
				preferences.remindThemeName.value = "false";
				savePreferences();
			}
		}
		themeName = prompt("Theme name:",preferences.textFont.value + " theme","Name Dialog", "OK", "Cancel");
		if (themeName == "") return; // user canceled
	}
	
	data = getCurrentThemeStr(themeName);
	
	if (defaultTheme)
	{
		preferences.theme0.value = data;
		print(data);
	}
	else
	{
		// Compare theme names

		theme1 = preferences.theme1.value.split(',');
		theme2 = preferences.theme2.value.split(',');
		theme3 = preferences.theme3.value.split(',');
		theme4 = preferences.theme4.value.split(',');
		theme5 = preferences.theme5.value.split(',');

		if (themeName == theme1[0])
		{
			preferences.theme1.value = data;
		}
		else if (themeName == theme2[0])
		{
			preferences.theme2.value = preferences.theme1.value;
			preferences.theme1.value = data;
		}
		else if (themeName == theme3[0])
		{
			preferences.theme3.value = preferences.theme2.value;
			preferences.theme2.value = preferences.theme1.value;
			preferences.theme1.value = data;
		}
		else if (themeName == theme4[0])
		{
			preferences.theme4.value = preferences.theme3.value;
			preferences.theme3.value = preferences.theme2.value;
			preferences.theme2.value = preferences.theme1.value;
			preferences.theme1.value = data;
		}
		else
		{
			preferences.theme5.value = preferences.theme4.value;
			preferences.theme4.value = preferences.theme3.value;
			preferences.theme3.value = preferences.theme2.value;
			preferences.theme2.value = preferences.theme1.value;
			preferences.theme1.value = data;
		}
	}
}

function getCurrentThemeStr(name)
{
	if (name == "") { name = "current"; }
	
	return (name + "," + 
		preferences.textFont.value + "," + 
		preferences.fontSize.value + "," + 
		preferences.lineHeight.value + "," + 
		preferences.textJustify.value + "," + 
		preferences.textColor.value + "," + 
		preferences.textOpacity.value + "," +
		preferences.bgColor.value + "," + 
		preferences.bgOpacity.value + "," + 
		preferences.marginWidth.value
	);
}

function compareTheme(number)
{
	temp = getCurrentThemeStr();
	current = temp.split(',');
	
	temp = eval("preferences.theme" + number + ".value");
	theme = temp.split(',');
	
	for (i=1; i<current.length; i++)
	{
		if (current[i] != theme[i]) return false;
	}
	
	return true;
}

function loadTheme(number)
{
	var values;
	temp = eval ("preferences.theme" + (1.0 * number) + ".value");
	values = temp.split(',');
	
	preferences.textFont.value 		= values[1];
	preferences.fontSize.value 		= 1.0 * values[2];
	preferences.lineHeight.value 	= 1.0 * values[3];
	preferences.textJustify.value 	= values[4];
	
	preferences.textColor.value 	= values[5];
	preferences.textOpacity.value	= 1.0 * values[6];
	preferences.bgColor.value 		= values[7];
	preferences.bgOpacity.value 	= 1.0 * values[8];
	preferences.marginWidth.value 	= 1.0 * values[9];
	
	updateDisplay(false);
}	

function clearSavedThemes()
{
	preferences.theme1.value = "";
	preferences.theme2.value = "";
	preferences.theme3.value = "";
	preferences.theme4.value = "";
	preferences.theme5.value = "";

	savePreferences();
}

function revealQuotes()
{
	if (filesystem.itemExists(system.userDocumentsFolder + "/" + sourceFileName))
	{
		filesystem.reveal(system.userDocumentsFolder + "/" + sourceFileName);
	}
	instructUser();
}

function openQuotes()
{
	if (filesystem.itemExists(system.userDocumentsFolder + "/" + sourceFileName))
	{
		filesystem.open(system.userDocumentsFolder + "/" + sourceFileName);
	}
	instructUser();
}

function loadQuotes()
{
	if (!filesystem.itemExists(system.userDocumentsFolder + "/" + sourceFileName))
	{
		alert("A sample set of inspirational quotes has been copied to "+ system.userDocumentsFolder + "/" + sourceFileName);
		filesystem.copy("Resources/inspiration.txt", system.userDocumentsFolder + "/" + sourceFileName);
	}

	quotations = filesystem.readFile( system.userDocumentsFolder + "/" + sourceFileName, true );
}

function randomQuote()
{
	if (quotations.length > 0)
	{
		return quotations[random(0,quotations.length)];
	}
	else
	{
		return "Something may be wrong with your quotes file: " + sourceFileName + ".";
	}
}

function timerAction()
{
	var now = new Date().valueOf();
	if (now - lastUpdate > (1.0 * preferences.frequency.value))
	{
		updateDisplay(true);
	}
}

function setRecycleGadget()
{
	recycle.vOffset = 4;
	recycle.width = 16;
	recycle.height = 16;

	if (preferences.textJustify.value == "right")
	{
		recycle.hOffset = mainWindow.width - recycle.width - 4;
	}
	else if (preferences.textJustify.value == "center")
	{
		recycle.hOffset = mainWindow.width / 2 - recycle.width / 2;
	}
	else
	{
		recycle.hOffset = 4;
	}
	recycle.zOrder = ++maxZOrder;
}

function updateDisplay(reloadQuote)
{
	suppressUpdates();

	maxWidth = 0;
	longestLine = -1;
	maxVOffset = 0;

	margin = 1.0 * preferences.marginWidth.value * preferences.fontSize.value / 100;

	if (reloadQuote)
	{
		// Reset the arrays...
		if (textObjs.length > 0)
		{
			for (var i=0; i<textObjs.length; i++) { delete textObjs[i]; }
		}

		quote = randomQuote();
		textLines = quote.split("*");
		while ((quotations.length > 1 && quote == lastQuote) || textLines.length == 0)
		{
			quote = randomQuote();
			textLines = quote.split("*");
		}
		lastQuote = quote;
		lastUpdate = new Date().valueOf();
	}
	
	// Determine the line height, if necessary
	lineHeight = 1.0 * preferences.lineHeight.value / 100 * preferences.fontSize.value;

	maxZOrder = 1;
	for (i=0; i<textLines.length; i++)
	{
		textObjs[i] = new Text();
		textObjs[i].opacity = preferences.textOpacity.value;
		textObjs[i].bgColor = "#FFFFFF";
		textObjs[i].bgOpacity = 0;
		textObjs[i].color = preferences.textColor.value;
		textObjs[i].font = preferences.textFont.value;
		textObjs[i].size = 1.0 * preferences.fontSize.value;
		textObjs[i].data = textLines[i];
		if (i == 0)
		{
			textObjs[i].vOffset  = (1.0 * preferences.fontSize.value) + margin;
		}
		else
		{
			textObjs[i].vOffset = textObjs[i-1].vOffset + lineHeight;
		}
		maxVOffset = 1.0 * textObjs[i].vOffset;

		maxZOrder += 1;
		textObjs[i].zOrder = maxZOrder; // Just greater than backdrop is fine;
		
		if (textObjs[i].width > maxWidth)
		{
			maxWidth = textObjs[i].width;
			longestLine = i;
		}
	}

	// If the textJustification has changed, we need to make some adjustments
	oldWidth = mainWindow.width;
	mainWindow.width = maxWidth + margin * 2;

	if (initialState)
	{
		// Reset initial state
		initialState = false;	
		if (preferences.textJustify.value == "right")
		{
			mainWindow.hOffset = (1.0 * preferences.anchorOffset.value) - mainWindow.width;
		}
		else if (preferences.textJustify.value == "center")
		{
			mainWindow.hOffset = (1.0 * preferences.anchorOffset.value) - (mainWindow.width) / 2;
		}
		else
		{
		}
	}
	else
	{
		if (oldWidth != mainWindow.width || preferences.textJustify.value != lastJustify)
		{
			if (preferences.textJustify.value == "right")
			{
				mainWindow.hOffset += oldWidth - mainWindow.width;
				preferences.anchorOffset.value = mainWindow.hOffset + mainWindow.width;
			}
			else if (preferences.textJustify.value == "center")
			{
				mainWindow.hOffset += (oldWidth - mainWindow.width) / 2;
				preferences.anchorOffset.value = mainWindow.hOffset + mainWindow.width / 2;
			}
			else // left
			{
				preferences.anchorOffset.value = mainWindow.hOffset;				
			}

			lastJustify = preferences.textJustify.value;
		}
	}

	mainWindow.height = maxVOffset + margin + lineHeight - preferences.fontSize.value;

	// Now we know the longest line, so we can now center the text if necessary
	for (var i=0; i<textLines.length; i++)
	{
		textObjs[i].alignment = preferences.textJustify.value;
		if (preferences.textJustify.value == "right")
		{
			textObjs[i].hOffset = maxWidth + margin;
		}
		else if (preferences.textJustify.value == "left")
		{
			textObjs[i].hOffset = margin;
		}
		else
		{
			textObjs[i].hOffset = (maxWidth / 2) + margin;
		}
	}
	
	// If we're using a background, place it
	if (preferences.bgOpacity.value > 0)
	{
		backdrop.hOffset = 0;
		backdrop.vOffset = 0;
		backdrop.width  = mainWindow.width;
		backdrop.height = mainWindow.height;
		backdrop.colorize = preferences.bgColor.value;
		backdrop.opacity = preferences.bgOpacity.value;
	}
	else { backdrop.opacity = 0; }

	setRecycleGadget();

	savePreferences();
	updateNow();
	resumeUpdates();
}

loadQuotes();
updateDisplay(true);
